//                                          pmp@math.univ.gda.pl  2004
#include <stdio.h>
#include <stdlib.h>

#define SZER_EKR 80  /* szerokosc ekranu */
#define IL_POZ   5   /* ilosc poziomow drzewa, ktore beda wydrukowane   */
                     /* gwiazdka bedzie sygnalizowac istnienie nizszych */
                     /* poziomow                                        */

/* struktury danych do reprezentowania drzewa */
typedef struct wezel *Wskwezla; /* wskaznik na wezel drzewa  */
typedef struct wezel{
	int klucz;
	Wskwezla lewy, prawy, ojciec;
} Twezla ;  /* typ wezla */

/* funkcja drukujaca drzewo binarne na ekranie (tutaj tylko deklaracja) */
/* funkcja drukuje drzewo o korzeniu "w"                                */
void drukuj(Wskwezla w);

/* funkcja budujaca pelne drzewo binarne o wysokosci n;       */
/* kluczami sa kolejne liczby  naturalne zaczynajac od 1      */
Wskwezla buduj(int n);

/* funkcja szukajaca element n */
Wskwezla szukaj(int n, Wskwezla drzewo);

/* kasuje element ktory juz mamy znaleziony ;) */ 
int kasujElement (Wskwezla element);
int kasuj (int n, Wskwezla drzewo);

/* ------------  implementacja ------------------------------------- */
char wydruk[IL_POZ+1][SZER_EKR];

Wskwezla szukaj (int n, Wskwezla drzewo)
{
 if (drzewo == NULL) return NULL;
 if (drzewo->klucz == n ) return drzewo;
 else if (drzewo->klucz < n) return szukaj(n,drzewo->prawy);
 else return szukaj(n,drzewo->lewy);
}

int kasujElement (Wskwezla element)
{
 Wskwezla temp;
 
 if (element == NULL) return(-1);

 // prawy i lewy - null
 if ((element->prawy == NULL) && (element->lewy == NULL)) {
  if((element->ojciec)->klucz > element->klucz)
   {
     (element->ojciec)->lewy = NULL;
   } else
   {
     (element->ojciec)->prawy = NULL;
   }
  free(element);
  return(0);
 }


// jesli nie korzen :)

 if (element->ojciec !=NULL) {

// prawy null / lewy nie null

 if((element->prawy == NULL) && (element->lewy !=NULL)) {
 (element->lewy) -> ojciec = element->ojciec;
  if((element->ojciec)->klucz < element->klucz)
     (element->ojciec)->prawy = element->lewy;
    else
     (element->ojciec)->lewy = element->lewy;
 free(element);
 return (0);
 }

// prawy nie null // lewy null

 if((element->prawy != NULL) && (element->lewy == NULL)){
  (element->prawy) -> ojciec = element->ojciec;
  if((element->ojciec)->klucz < element->klucz)
     (element->ojciec)->prawy = element->prawy;
    else
     (element->ojciec)->lewy = element->prawy;

 free(element);
 return(0);
 }

} // koniec element nie ojecie

// element ojciec :)

else {
 temp=NULL; 
 if(element->lewy == NULL && element->prawy!=NULL)
 {
  temp = element->prawy; 
 } else if (element->lewy!=NULL && element->prawy==NULL)
   { temp=element->lewy; }

 if(temp!=NULL) {
  element->klucz=(temp)->klucz;
  element->lewy = (temp)->lewy;
  element->prawy = (temp)->prawy;
  (element->lewy)->ojciec = element;
  (element->prawy)->ojciec = element;
  free(temp);
}

 }



// oba nie nulle :)

 temp = element -> prawy;

 while (temp->lewy != NULL) {
  temp = temp-> lewy;
 } 
 element->klucz = temp -> klucz;

 return (kasujElement(temp));

}


int kasuj (int n, Wskwezla drzewo)
{
  return kasujElement(szukaj(n,drzewo));
}


void drukujost(Wskwezla w, int l, int p,int poziom){
       int srodek = (l+p)/2;
       if (w==NULL)    return;
       wydruk[poziom][srodek]='*';
}

void drukujwew(Wskwezla w, int l, int p,int poziom){
       int srodek = (l+p)/2;
       int i,dl;
       char s[9];
       if (w==NULL)    return;
       dl=sprintf(s,"%d",w->klucz);
       for (i=0;i<dl;i++)
         wydruk[poziom][srodek-dl/2+i]=s[i];
       if (++poziom<IL_POZ){
         drukujwew(w->lewy,l,srodek,poziom) ;
         drukujwew(w->prawy,srodek+1,p,poziom) ;
       }
       else {
         drukujost(w->lewy,l,srodek,poziom) ;
         drukujost(w->prawy,srodek+1,p,poziom) ;
       }
}

void drukuj(Wskwezla w){
  int j,i;
  for (i=0;i<=IL_POZ;i++)
    for (j=0;j<SZER_EKR;j++)
      wydruk[i][j] = ' ';
  drukujwew(w,0,SZER_EKR,0);
  for (i=0;i<=IL_POZ;i++){
      for (j=0;j<=SZER_EKR;j++)
        putchar(wydruk[i][j]);
      printf("\n");
  }
}

/* 2 do potegi n - fun. pomocnicza */
int potega(int n){
	if (n==0)  return 1;
	else       return 2*potega(n-1) ;
}

Wskwezla buduj1(int n, int przesuniecie, Wskwezla ojciec){
    Wskwezla w = (Wskwezla) malloc(sizeof(Twezla));
    if (n==0) return NULL;
    w->klucz = (potega(n-1)+przesuniecie)*1;
    w->ojciec=ojciec;
    w->lewy = buduj1(n-1,przesuniecie,w);
    w->prawy = buduj1(n-1,przesuniecie+potega(n-1),w);
    return w;
}
Wskwezla buduj(int n){
  Wskwezla w = buduj1(n+1,0,NULL);
  return w;
}

/* ----------------- program testujacy -----------------------*/

int main(){
     int n;
     char c;
     Wskwezla w;
     printf("podaj wysokosc drzewa (0..4) ");
     scanf("%d", &n);
     w=buduj(n);
     drukuj(w);

     do {
     printf("jaki element usunac? ");
     scanf("%d", &n);
     if (kasuj(n,w)==0) {
     printf("drzewo po wywaleniu elementu %d...\n",n);
     drukuj(w);
     printf("czy jeszcze jedno wywalanie (T/N) ?\n");
     scanf("%c",&c);
     }

     else printf("nie udalo sie wywalic ... moze nie ma takiego elementu?\n");
     getchar();
     } while (c!='n' && c!='N');

     return(0);
}
     





