//                                          pmp@math.univ.gda.pl  2004
#include <stdio.h>
#include <stdlib.h>
#include <term.h>
#include <math.h>

//#define SZER_EKR 80  /* szerokosc ekranu */
//#define IL_POZ   5   /* ilosc poziomow drzewa, ktore beda wydrukowane   */
                     /* gwiazdka bedzie sygnalizowac istnienie nizszych */
                     /* poziomow                                        */

/* struktury danych do reprezentowania drzewa */
typedef struct wezel *Wskwezla; /* wskaznik na wezel drzewa  */
typedef struct wezel{
	int klucz;
	Wskwezla lewy, prawy, ojciec;
} Twezla ;  /* typ wezla */

/* funkcja drukujaca drzewo binarne na ekranie (tutaj tylko deklaracja) */
/* funkcja drukuje drzewo o korzeniu "w"                                */
void drukuj(Wskwezla w);

/* funkcja budujaca pelne drzewo binarne o wysokosci n;       */
/* kluczami sa kolejne liczby  naturalne zaczynajac od 1      */
Wskwezla buduj(int n);

/* ja@hope.art.pl dopisalem te funkcje: */

/* funkcja szukajaca element n */
/* zwraca wskaznik do wezla jesli sie uda, NULL jest nie */
Wskwezla szukaj(int n, Wskwezla drzewo);

/* w - element to skasowania, root obecny korzen drzewa */
/* zwraca korzen */
Wskwezla kasujElement (Wskwezla w , Wskwezla root);

/* n - wartosc do skasowania, root - korzen drzewa */
/* zwraca korzen */
Wskwezla kasuj (int n, Wskwezla root);

/* ------------  implementacja ------------------------------------- */
// char wydruk[IL_POZ+1][SZER_EKR];

char **wydruk;
int SZER_EKR;
int IL_POZ;

/* to dopisalem ja .... ja@hope.art.pl */

Wskwezla szukaj (int n, Wskwezla root) {
 if (root == NULL) return NULL;
 if (root->klucz == n ) return root;
 else if (root->klucz < n) return szukaj(n,root->prawy);
 else return szukaj(n,root->lewy);
}

Wskwezla minimumPoddrzewa(Wskwezla w) {
 if(w==NULL) return(NULL);
 if(w->lewy==NULL) return(w);
 else return(minimumPoddrzewa(w->lewy));
}

Wskwezla kasujElement (Wskwezla w,Wskwezla root) {
 Wskwezla x,y;
 
 if(w==NULL) return(root);

 if(w->lewy==NULL || w->prawy==NULL) y=w;
  else y = minimumPoddrzewa(w->prawy);

 if(y->lewy != NULL) x = y->lewy; 
   else x = y->prawy;

 if(x!=NULL) x->ojciec = y->ojciec;

 if (y==root) {
   free(root);
   if(x!=NULL)x->ojciec=NULL;
   return(x);
   }

 else {
  if(y == y->ojciec->lewy) y->ojciec->lewy = x;
  else y->ojciec->prawy = x;
  }

 if(y!=w) w->klucz=y->klucz;

 free(y);
 return(root);
}


Wskwezla kasuj (int n, Wskwezla root) {
  return kasujElement(szukaj(n,root),root);
}

/* ************************************************** */

void drukujost(Wskwezla w, int l, int p,int poziom) {
       int srodek = (l+p)/2;
       if (w==NULL)    return;
       wydruk[poziom][srodek]='*';
}

void drukujwew(Wskwezla w, int l, int p,int poziom) {
       int srodek = (l+p)/2;
       int i,dl;
       char s[9];
       if (w==NULL)    return;
       dl=sprintf(s,"%d",w->klucz);
       for (i=0;i<dl;i++)
         wydruk[poziom][srodek-dl/2+i]=s[i];
       if (++poziom<IL_POZ){
         drukujwew(w->lewy,l,srodek,poziom) ;
         drukujwew(w->prawy,srodek+1,p,poziom) ;
       }
       else {
         drukujost(w->lewy,l,srodek,poziom) ;
         drukujost(w->prawy,srodek+1,p,poziom) ;
       }
}

void drukuj(Wskwezla w) {
  int j,i;
  
  if (w==NULL) { printf("drzewo jest puste\n");
  		return;
  	}	

  for (i=0;i<=IL_POZ;i++)
    for (j=0;j<SZER_EKR;j++)
      wydruk[i][j] = ' ';
  drukujwew(w,0,SZER_EKR,0);
  for (i=0;i<=IL_POZ;i++){
      for (j=0;j<=SZER_EKR;j++)
        putchar(wydruk[i][j]);
      printf("\n");
  }

}

/* 2 do potegi n - fun. pomocnicza */
int potega(int n) {
	if (n==0)  return 1;
	else       return 2*potega(n-1) ;
}

Wskwezla buduj1(int n, int przesuniecie, Wskwezla ojciec){
    Wskwezla w = (Wskwezla) malloc(sizeof(Twezla));
    if (n==0) return NULL;
    w->klucz = (potega(n-1)+przesuniecie)*1;
    w->ojciec=ojciec;
    w->lewy = buduj1(n-1,przesuniecie,w);
    w->prawy = buduj1(n-1,przesuniecie+potega(n-1),w);
    return w;
}

Wskwezla buduj(int n){
  Wskwezla w = buduj1(n+1,0,NULL);
  return w;
}

/* ----------------- program testujacy -----------------------*/

int main(){
     int n,i;
     Wskwezla w;

     tgetent(NULL,getenv("TERM"));
     SZER_EKR=tgetnum("co");
     IL_POZ=rintf(log10((float)tgetnum("li"))/log10(2));

     printf("SZER_EKR: %d\t", SZER_EKR);
     printf("IL_POZ=%d\n",IL_POZ);

     wydruk = (char**)malloc((IL_POZ+1)*sizeof(char*));

     for(n=0;n<(IL_POZ+1);n++)
     wydruk[n]=(char*)malloc(SZER_EKR*sizeof(char));

     printf("podaj wysokosc drzewa (0..%d) ",IL_POZ-1);
     scanf("%d", &n);
     w=buduj(n);
     drukuj(w);

     do {
     printf("jaki element usunac (podaj -1 zeby skonczyc): ");
     scanf("%d", &n);

     if ((w=kasuj(n,w))!=NULL) {
        printf("Obecny stan drzewa:\n");
        drukuj(w);
     }
     else 
        printf("drzewo jest puste\n");

     } while (n!=-1 && w!=NULL);
     
     printf("koniec.\n");
     return(0);
}
     





