// haszowanie - wczytuje liczby .. do int (czyli ograniczony zakres)

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <time.h>

////////////////////////////// funkcja haszujace :D

int h1 (int k,int size)
{
 return(k % size);
}

int h2 (int k,int size)
{
 return( ( k % (size-2) )+1); 
}

int h(int k,int i, int size)
{
 return((h1(k,size) + i*h2(k,size))%size );
}

//////////////////////////////////// 

int hash_insert(int **tablica,int *key, int size)
{
 int i=0,temp;

 do {
 temp = h(*key,i,size);
 if (tablica[temp]==NULL)
 	{
	 tablica[temp]=key;
	 break;
	}
 else i++;
 }
 while (i<=size);

 if (i>size) {
  return(-1);
 }

 return(i+1);


}



/////////////////////////////////// funkcje pomocnicze

void print_table(int **tablica,int size)
{
 int i;

 for(i=0;i<size;i++)
 { 
  printf("tablica[%d] = ",i);
  if (tablica[i]==NULL) printf("wolne miejsce!\n");
  else printf("%d\n",*tablica[i]);
 }

}


/////////////////////////////////// main

int main(int argc, char **argv)
{
 int n,p;
 int size;

 int **tablica;
 int *tRecord;
 
 int wstawienia=0;
 
 int i,j;

 char debug_mode=1;

 if (argc>1)
 {
  for(i=1;i<argc;i++)
    if(strcmp(argv[i],"--quite")==0) debug_mode=0;
 }

 if (debug_mode) {
 printf("podaj: size p n\n");
 }

 scanf("%d %d %d",&size, &p, &n);

 if ((n+p)>size) {
	fprintf(stderr,"ERROR: nie da sie umiescic %d liczba w %d-elementowej tablicy!\n",n,size);
	exit(-1);
	}

 if(debug_mode) {
 	printf("INFO: tablica bdzie miaa %d miejsc\n",size);
 }

 tablica = (int**)calloc(size,sizeof(int*));

 // wypelniamy losowo tablice!

 if(debug_mode) {
 	printf("INFO: wstawiam do tablicy %d losowych liczb parzystych\n",p);
 }


 srand(time(NULL));
 for(i=0;i<p;i++)
 { 
   tRecord = (int*)malloc(sizeof(int));
   *tRecord = (rand() % ((RAND_MAX-1) / 2)) * 2;
   if(hash_insert(tablica,tRecord,size)==-1) {
     fprintf(stderr,"ERROR: nie da sie wstawic elementu %d do tablicy!\n",*tRecord);
     exit(-1);
   }
 }

 if(debug_mode) {
 	printf("podaj teraz %d liczb(y) ktore maja byc dodane..\n",n);
 }

 for(i=0;i<n;i++) {

 tRecord = (int*)malloc(sizeof(int));
 scanf("%d",tRecord);

 j=hash_insert(tablica,tRecord,size);

 if(j==-1) {
   fprintf(stderr,"ERROR: nie da sie wstawic elementu %d do tablicy!\n",*tRecord);
   exit(-1);
   }

  wstawienia+=j;
 }

 if (debug_mode) {
 printf("INFO: oto nasza tablica:\n");
 print_table(tablica,size);
 }

 printf("INFO: srednia liczba proba przy wsatwianiu elementu: %f\n",ceil((float)wstawienia/(float)n));

 return(0);
}
