// program haszuje napisy :>

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

////////////////////////////// funkcja haszujace :D

int h1 (int k,int size)
{
 return(k % size);
}

int h2 (int k,int size)
{
 return( ( k % (size-2) )+1); 
}

int h(int k,int i, int size)
{
 return((h1(k,size) + i*h2(k,size))%size );
}

int checksum(char *napis,int len)
{
 int i=0,wynik;

 if(len!=0) wynik = 256 * napis[0] + napis[1];

 if (len>2) {
  for (i=2;i<len;i+=2)
  wynik = wynik ^ (256*napis[i]+napis[i+1]);
}
 if (i==len-2) wynik = wynik ^ napis[len-1];

return(wynik);

}
/////////////////////////////////// utility functions :)

void print_table(char **tablica,int size)
{
 int i;

 for(i=0;i<size;i++)
 { 
  printf("tablica[%d] = ",i);
  if (tablica[i]==NULL) printf("wolne miejsce!\n");
  else printf("%s\n",tablica[i]);
 }

}


/////////////////////////////////// main

int main(int argc, char **argv)
{
 int n;
 int m;

 char **tablica;
 char *napis;

 int wstawienia=0;
 int temp;

 int tRecord;
 int i,j;

 char debug_mode=1;

 if (argc>1)
 {
  for(i=1;i<argc;i++)
    if(strcmp(argv[i],"--quite")==0) debug_mode=0;
 }
 
 if (debug_mode) {
 printf("podaj: n size\n");
 }

 scanf("%d %d",&n,&m);
 temp=getchar();

 if (n>m) {
	fprintf(stderr,"ERROR: nie da sie umiescic %d liczba w %d-elementowej tablicy!\n",n,m);
	exit(-1);
	}

 tablica = (char**)calloc(m,sizeof(char*));

 if (debug_mode) {
 printf("podaj %d napisow:\n",n);
 }

 for(i=0;i<n;i++) {

 j=0;

 while ( ( temp=getchar() ) != '\n') {
   napis = realloc(napis,j+2);
   napis[j]=temp;
   napis[++j] = '\0';
 }

 tRecord = checksum(napis,j);
 j = 0;

 do {
 temp = h(tRecord,j,m);
 if (tablica[temp]==NULL)
 	{
	 tablica[temp]=napis;
	 break;
	}
 else j++;
 }
 while (j<=m);

 napis = NULL;

 if (j>m) {
  fprintf(stderr,"ERROR: nie da sie wstawic elementu %s do tablicy!\n",napis);
  exit(-1);
 }

 wstawienia+=(j+1);
}

 if (debug_mode) {
 printf("INFO: oto nasza tablica:\n");
 print_table(tablica,m);
 }

 printf("INFO: srednia liczba proba przy wsatwianiu elementu: %f\n",ceil((float)wstawienia/(float)n));

 return(0);

}
