/*
Najdluzszy wspolny podciag (programowanie dynamiczne)

Napisac program implementujacy algorytm wyszukiwania najdluzszego
wspolnego podciagu metoda programowania dynamicznego. Zademonstrowac
dzialanie programu na reprezentatywnych danych testowych (moga byc
ustalone na sztywno w programie).

(B) wersja nie uzywajaca pomocniczej tablicy "b" (patrz: podpunkt
"Ulepszanie algorytmu") [5 punktow]
*/

/* (c) 2005 Witold Bot */

#include <stdio.h>
#include <stdlib.h>

int **c;

void LCS_Lenght(char *X, char *Y) {
	int m,n,i,j;

	m = strlen(X);
	n = strlen(Y);

	c = (int**)calloc((m+1),sizeof(int*));
	for(i=0;i<m+1;i++)
	 c[i] = (int*)calloc((n+1),sizeof(int));

	for(i=1;i<=m;i++) 
	 for(j=1;j<=n;j++) {
			if(X[i-1] == Y[j-1]) {
		   		c[i][j] = c[i-1][j-1]+1;
		   	} 
		   	else if (c[i-1][j]>=c[i][j-1]) {
		   		c[i][j]=c[i-1][j];
		   	} 
		   	else {
		   		c[i][j] = c[i][j-1];
		   	}
		}


}

void Print_LCS(char *X,int i, int j) {
	if(i==0 || j==0) return;

	if (c[i][j]==c[i-1][j]) {
		Print_LCS(X,i-1,j);
		}
	else if (c[i][j]==c[i][j-1]) { Print_LCS(X,i,j-1);}
	else if(c[i][j] == c[i-1][j-1]+1) {
		Print_LCS(X,i-1,j-1);
		printf("%c",X[i-1]);
		}
}

int main()
{
  char *X=NULL,*Y=NULL,c;
  int i=0,j=0;

  printf("X\t= ");
  while((c=getchar())!='\n' && c!=EOF) {
   X = realloc(X,i+2);
   X[i++]=c;
   X[i]=0;
   }

  printf("Y\t= ");
  while((c=getchar())!='\n') {
   Y = realloc(Y,j+2);
   Y[j++]=c;
   Y[j]=0;
   }

  printf("LCS\t= ");
  LCS_Lenght(X,Y);
  Print_LCS(X,i,j);
  printf("\n");
  return(0);

}
