/*
Najdluzszy wspolny podciag (programowanie dynamiczne)

Napisac program implementujacy algorytm wyszukiwania najdluzszego
wspolnego podciagu metoda programowania dynamicznego. Zademonstrowac
dzialanie programu na reprezentatywnych danych testowych (moga byc
ustalone na sztywno w programie).

(C) wersja rekurencyjna ze spamietywaniem, wzorowana na podpunkcie
"Spamietywanie" rozdzialu wczesniejszego [5 punktow]

*/

/* (c) 2005 Witold Bot */

#include <stdio.h>
#include <stdlib.h>

int **c;

int CalC(int i,int j,char *X,char *Y) {
	int a,b;

   if(c[i][j]==-1) {
   if((i==0) || (j==0)) c[i][j]=0;
   else if(X[i-1]==Y[j-1]) c[i][j]=CalC(i-1,j-1,X,Y)+1;
   else {
   a = CalC(i,j-1,X,Y);
   b = CalC(i-1,j,X,Y);
   c[i][j] = (a>=b ? a : b);
   }
  }
 return c[i][j];
}

void Print_LCS(char *X,char *Y,int i, int j) {
	if(i==0 || j==0) return;

	if (CalC(i,j,X,Y)==CalC(i-1,j,X,Y)) {
		Print_LCS(X,Y,i-1,j);
		}
	else if (CalC(i,j,X,Y)==CalC(i,j-1,X,Y)) { Print_LCS(X,Y,i,j-1);}
	else if(CalC(i,j,X,Y) == CalC(i-1,j-1,X,Y)+1) {
		Print_LCS(X,Y,i-1,j-1);
		printf("%c",X[i-1]);
		}
}


int main()
{
  char *X=NULL,*Y=NULL,z;
  int i,j,m=0,n=0;

  printf("X\t= ");
  while((z=getchar())!='\n' && z!=EOF) {
   X = realloc(X,m+2);
   X[m++]=z;
   X[m]=0;
   }

  printf("Y\t= ");
  while((z=getchar())!='\n' && z!=EOF) {
   Y = realloc(Y,n+2);
   Y[n++]=z;
   Y[n]=0;
   }

  c = (int**)malloc((m+1)*sizeof(int*));
  for(i=0;i<m+1;i++)
   { c[i] = (int*)malloc((n+1)*sizeof(int));
     for(j=0;j<=n;j++) c[i][j]=-1;
   }

  printf("LCS\t= ");
  Print_LCS(X,Y,m,n);
  printf("\n");
  return(0);
}
