// (c) 2004 Witold Bot

// zwyky quicksort z losowym wyborem elementu wyznaczajcego podzia
// i mierzeniem gbokoci rekursji

#include<stdio.h>
#include<stdlib.h>
#include<time.h>
#include<string.h>
#include<math.h>

int depth = -1; // zmienna globalna przechowuje aktualn gboko drzewa

void swap(int *A, int a, int b) 
{
int temp;

temp = A[a];
A[a] = A[b];
A[b] = temp;
} 

// troch inna wersja partition .. na podstawie wikipedii (haso quicksort)
int partition(int *A, int left, int right, int pI) 
{
  int pV = A[pI];
  int sI = left;
  int i;

  swap(A, pI, right);

  for (i = left; i < right; i++)
	if (A[i] <= pV) {
	    swap(A, sI, i);
	    sI++;
	}

  swap(A, right, sI);
    
  return (sI);
}

// troch inna wersja quicksorta (te na podstawie wikipedii, ale zmieniona
// eby liczy jeszcze gboko drzewa:)

void quicksort(int *A, int left, int right,int last_depth) 
{
int pivot;
int q;
    
if (last_depth==depth) depth++;

if (left < right) {
	pivot = left + (random() % (right - left + 1));
	q = partition(A, left, right, pivot);
	quicksort(A, left, q - 1,last_depth+1);
	quicksort(A, q + 1, right,last_depth+1);
    }

}


void print_table(int *A, int count) 
{
  int i;
  for (i = 0; i < count; i++)
  printf("%d ", A[i]);
  printf("\n");
}

// UWAGA! program jest przystosowany do pracy razem ze skryptem test.sh
// a nie z czowiekiem :) dlatego nie zadaje zbdnych pyta itd ...
// pierwsza liczb jak wczytuje to ile bdzie elementw do sortowania
// potem wczytuje te elementy no i sortuje je.
// jeli program uruchomimy z opcj --quite to nie wypisze adnego wyjcia
// poza gbokoci drzewa rekursji, jeli nie bdzie tej opcji pojawi si
// te zawarto tablicy przed i po sortowaniu.

int main(int argc, char *argv[]) 
{
  int *dane;
  int  i, n;    
  char quite_mode = 1;

  if (argc > 1) {
	for (i = 1; i < argc; i++)
		if (!(strcmp(argv[i], "--quite")))
			quite_mode = 0;
  }

  srand(time(NULL));
    
  scanf("%d", &n);

  dane = (int *) malloc(n * sizeof(int));

  for (i = 0; i < n; i++)
  	scanf("%d", dane + i);

  if (quite_mode != 0) {
    printf("tablica przed sortowaniem:\n");
    print_table(dane, n);
  }
    
  quicksort(dane, 0, n - 1,depth);

  if (quite_mode != 0) {
    printf("tablica po sortowaniu:\n");
    print_table(dane, n);
  }

  printf("maksymalna glebokosc rekursji = %d\n",depth);

  return (0);
}



