// quicksort z losowym wyborem elementu wyznaczajcego podzia oraz z
// dodanym bubble sortem dla przedziaw o dugoci mniejszej od __G no i
// z mierzeniem gbokoci drzewa rekursji

// dziaa prawie tak samo jak qsort.c wic opis kodu jest szcztkowy :P

// (c) 2004 Witold Bot

#include<stdio.h>
#include<stdlib.h>
#include<time.h>
#include<string.h>
#include<math.h>

int __G=10;

int depth = -1;

void swap(int *A,int a, int b)
{
 int temp;
 temp = A[a];
 A[a] = A[b];
 A[b] = temp;
}

int partition(int *A,int left, int right, int pI)
{
 int pV = A[pI];
 int sI = left;
 int i;

 swap(A,pI,right);

 for (i=left;i<right;i++)
  if (A[i] <= pV) {
    swap(A,sI,i);
    sI++;
    }

 swap(A,right,sI);
 return(sI);
}

void bubble_sort(int *A,int left, int right)
{
 int i,j;

  for(i=left;i<=right;i++)
   for(j=right;j>i;j--)
    if(A[j]<A[j-1]) swap(A,j,j-1);

}


void quicksort(int *A, int left, int right, int last_depth)
{
  int pivot;
  int q;

  if (depth==last_depth) depth++;

  if(right - left+1 > __G) {
 	pivot = left + (random()%(right-left+1));
 	q = partition(A,left,right,pivot);
 	quicksort(A,left,q-1,last_depth+1);
 	quicksort(A,q+1,right,last_depth+1);
 }	
 else bubble_sort(A,left,right);
}

void print_table(int *A,int count)
{
 int i;
 for(i=0;i<count;i++)
  printf("%d ",A[i]);
 printf("\n");
}

int main(int argc,char *argv[])
{
  int *dane;
  int i,n;
  char quite_mode=1;

  if (argc > 1)
  {
   for(i=1;i<argc;i++)

   if (!(strcmp(argv[i],"--quite"))) quite_mode=0;

   else
   
   if (!(strcmp(argv[i],"--const"))) {
     i++;
     if (i<argc) sscanf(argv[i],"%d",&__G); 
   }
  }

  if(quite_mode!=0) printf("stala g=%d\n",__G);
  
  srand(time(NULL));

  scanf("%d",&n);
  dane = (int*)malloc(n*sizeof(int));
 
  for(i=0;i<n;i++)
   scanf("%d",dane+i);

 if(quite_mode!=0){
 printf("tablica przed sortowaniem:\n");
 print_table(dane,n);
 }

 quicksort(dane,0,n-1,depth);

 if(quite_mode!=0){
 printf("tablica po sortowaniu:\n");
 print_table(dane,n);
 }

 printf("maksymalna glebokosc rekursji = %d\n",depth);

 return(0);
}

