// (c) 2004 Witold Bot

// wejscie:
// program pobiera najpierw liczbe n ze standardowego wejscia
// a nastepnie n liczba calkowitych (nieujemnych!)

#include <stdlib.h>
#include <stdio.h>

#include <string.h>	// uzywane tylko do parsingu paramterow wywolania!

// globalne dane
 char **dane;  // wczytane dane
 int *dlugosc; // tablica dlugosci poszczegolnych napisow
 int count;    // ile jest danych                                          
 int max=-1;   // dlgosc najdluszego napisu!

void counting_sort(int current)
{
 int C[10] = {0,0,0,0,0,0,0,0,0,0}; // zainicjalizowana tablica C[]
 char **B;         // tablica pomocnicza ktora bedzie wynikiem dzialania funkcji
 int *dlugosc_new; // nowa tablica dlugosci!
 int tcurrent;
 int i;

 // potrzebujemy nowa pamiec! bo ... to sortowanie tworzy nowa tablice
 // i wypelnia ja danymi w odpowiedniej kolejnosci .. nie ruszajac starej
 // tablicy

 B = (char**)malloc(count*sizeof(char*));
 dlugosc_new = (int*)malloc(count*sizeof(int));

 // wypelniamy tablice C
 for (i=0;i<count;i++) {
 // ten fragmment jest dlatego zeby poradzic sobie w sytuacji gdy mamy
 // liczby roznej dlugosci (a zazwyczaj tak wlasnie bedzie)
  if (dlugosc[i] == max) 
  	tcurrent=current;
  else 
  	tcurrent = current - (max-dlugosc[i]);

 // no i wypelnianie C
  if(tcurrent>=0) 
  	C[(int)(dane[i][tcurrent]-48)]++;	// to -48 jest dlatego ze w
  else                                          // dane[i][tcureent] mamy 
  	C[0]++;                                 // znaczki ASCII a nie liczby!
 }

 for(i=1;i<10;i++) C[i] += C[i-1];    // konstrukcja C[] zgodnie z algorytmem

 // no i sortowanie
 for(i=count-1;i>=0;i--) {
 // dokladnie tak jak wyzej!
  if (dlugosc[i] == max) 
  	tcurrent=current;
  else 
  	tcurrent = current - (max-dlugosc[i]);
  
  // te warunki sa wlasnie dla liczby o mniejszej dlugosci niz najdluzsza liczba
  // w ciagu ... jesli aktualnie badna liczba ma cos jeszcze na current pozycji 
  // to zachodzi pierwszy przypadek
  if(tcurrent>=0) {
    	B[C[(int)(dane[i][tcurrent]-48)]-1] = dane[i];
    	dlugosc_new[ C[(int)(dane[i][tcurrent]-48)]-1 ] = dlugosc[i];
    	C[(int)(dane[i][tcurrent]-48)]--;
  } 

  // a jesli na pozycji current juz by nic nie bylo to ... to tak jakby jest 0
  else {
    	B[C[0]-1] = dane[i];
    	dlugosc_new[ C[0]-1 ] = dlugosc[i];
    	C[0]--;
  }
  // napisy B[ C[jakiindex] - 1] s dlatego e orygianlny algorytm zakada
  // e tablice s numerowane od 1 a nie od zera!

  // uwaga! w oryginalnej wersji algorytmu NIE ma mowy o tablicy dlugosci!
  // tu trzeba to dodac to jesli liczba zmienia swoje miejsce to oczywiscie
  // w tablicy z dlugosciami ta zmiana tez musi nastapic!

 } // koniec sortowania! teraz tablica B jest posortowana wedlug pozycji current

 // ostatnie co trzeba zrobic to wywalic stara tablica i zastapic ja nowa
 // instrukcja free(dane) nie znaczy ze wywalamy z pamieci wczytane dane!
 // a tylko w praktyce wywalamy ich stary porzadek ... nasze dane sa bezpieczne
 // w tablicy B :>
 free(dane);		// ale magia :)
 free(dlugosc);
 dane = B;
 dlugosc = dlugosc_new;
}

void radix()	// sortowanie pozycyjne :P
{
  int i;
  for(i=max-1;i>=0;i--)
     counting_sort(i);
}


void print_table()  // do debugowanie i w ogle :)
{
 int i;
 for(i=0;i<count;i++)
  printf("%d (len=%d): %s\n",i+1,dlugosc[i],dane[i]);
}

int main(int argc,char *argv[]) 
{
  int i,j;
  char temp;   // aktualnie wczytywany znaczek;

  char quite_mode = 1; // czy program ma siedziec cicho czy nie :)

  // najgupszy parsing parametrw wywoania na jaki mnie sta :P
  if (argc > 1) {
	for (i = 1; i < argc; i++)
		if (!(strcmp(argv[i], "--quite")))
			quite_mode = 0;
  }


  scanf("%d",&count);  // pobierz tzw. n :)
  temp=getchar();      // takie glupstwo 
  		       // - zagadka - co sie stanie jak tego nie bedzie:P

 if(count<=0) {
  printf("podano bezsensowne dane:P\n");
  printf("n musi byc wieksze od 0!\n");
  exit(-1);
 }

 // inicjalizacja pamieci :)

 dane = (char**)malloc(count*sizeof(char*));
 dlugosc = (int*)malloc(count*sizeof(int));

 // pobieramy liczby
 for(i=0;i<count;i++){
   j=0;		// j - zmienna pomocnicza dlatego bo pobieram znak po znaku
   while ((temp=getchar())!='\n') {
     dane[i] = realloc(dane[i],j+2);  // stary numer :) zeby pobierac duze napisy
     dane[i][j]=temp;     		
     dane[i][++j]='\0';   
   }
   dlugosc[i]=j;	// uzupelniamy tablice dlugosci
   if(dlugosc[i]>max)max=dlugosc[i]; // wyliczamy dlugosc najdluzszego napisu jaki jest
 }

  if (quite_mode != 0) {
    printf("tablica przed sortowaniem:\n");
    print_table();
  }
 
  radix();

  if (quite_mode != 0) {
    printf("tablica po sortowaniu:\n");
    print_table();
  }
   
  return(0);
}
