// (c) 2004 Witold Bot

// wersja edukacyjna kodu. (ISO-8859-2)

// wejscie:
// program pobiera najpierw liczbe n ze standardowego wejscia
// a nastepnie n liczba calkowitych (nieujemnych!)

#include <stdlib.h>
#include <stdio.h>

#include <string.h>	// uzywane tylko do parsingu paramterow wywolania!
			// czyli konkretnie chodzi o stwierdzenie czy 
			// program zosta uruchomiony z paramtrem --quite czy nie
			// poza tym program NIE korzysta z funkcji takich jak
			// strlen itd !

/*
uwagi oglne:
	* program czyta dane ze standardowego wejcia znak po znaku
	
	* program zapisuje dane w zmiennej typu char ** czyli w szczeglnoci
	  nie konwertuje wczytanych liczb na jakikolwiek typ liczbowy - one
	  pozostaj napisami cay czas
	
	* program tylko raz wylicza dugo kadego z napisw - jest to w 
	  momencie wczytywanie danych z wejcia standardowego i do tego celu
	  nie uywa adnej mdrej funkcji! bo po co? :P

	* program stara si uywa mao pamici! wobec czego w algorytmie
	  counting sort nie przepisuje danych do nowej tablicy tylko robi
	  "sztuczki" ze wskanikami, tak e mamy jedn kopi danych w pamici
	  tylko, ale za to dwie tablice ktre ustalaj kolejno tych danych..
	  potem t star niszczymy i ta nowa staje jedyn obowizujc :>
*/


// zmienne globalne
 char **dane;  // wczytane dane
 int *dlugosc; // tablica dlugosci poszczegolnych napisow
 int count;    // ile jest danych                                          
 int max=-1;   // dlgosc najdluszego napisu!
 char quite_mode = 1; // czy program ma siedziec cicho czy nie :)

// current to jest pozycja w zapiszie dziesitnych wedug ktrej mamy sortowa!
void counting_sort(int current)
{
 int C[10] = {0,0,0,0,0,0,0,0,0,0}; // zainicjalizowana tablica C[]
 char **B;         // tablica pomocnicza ktora bedzie wynikiem dzialania funkcji
 int *dlugosc_new; // nowa tablica dlugosci!

 int tcurrent; // ta zmienna zawiera bdzie przeliczon warto current tak
               // eby w napisach o dugoci mniejszej od max nie byo wyjcia
               // poza napis i eby rzeczywicie dobra pozycja bya brana pod
               // uwag! jak sobie wyobrazimy dwie liczby na przykad: 24 i 3216
               // i jeli chcemy je posortowa wedug ostatniej pozycji .. to
               // ta "ostatnia pozycja dla pierwszej liczby to jest 1, a dla
               // drugiej - 3 (pozycje numerujemy od 0 :)) no a jeli chcemy
               // sortowa wedug pierwszej pozycji (najbardziej znaczcej) to
               // dla drugiej liczby to jest pozycja 0, a dla pierwszej ...
               // jest to "wirtualna pozycja" - w moim programie -1, i tam przyjmuje
               // si, e jest wpisane 0, wobec czego liczba 24 jest tak naprawd
               // liczb 0024 (ale w pamici zapisujemy tylko "24")!
 
 int i;

 // potrzebujemy nowa pamiec! bo ... to sortowanie tworzy nowa tablice
 // i wypelnia ja danymi w odpowiedniej kolejnosci .. nie ruszajac starej
 // tablicy

 B = (char**)malloc(count*sizeof(char*));
 dlugosc_new = (int*)malloc(count*sizeof(int));

 // zadniem tej petli jest przygotowanie tablicy C
 for (i=0;i<count;i++) {
 // ten fragmment jest dlatego zeby poradzic sobie w sytuacji gdy mamy
 // liczby roznej dlugosci (a zazwyczaj tak wlasnie bedzie)
  if (dlugosc[i] == max) 
  	tcurrent=current;
  else 
  	tcurrent = current - (max-dlugosc[i]);

 // no i wypelnianie tablicy wartosciami C
  if(tcurrent>=0) 
  	C[(int)(dane[i][tcurrent]-48)]++;	// to -48 jest dlatego ze w
  else                                          // dane[i][tcureent] mamy 
  	C[0]++;                                 // znaczki ASCII a nie liczby!
 }

 for(i=1;i<10;i++) C[i] += C[i-1];    // konstrukcja C[] zgodnie z algorytmem

 // no i sortowanie
 for(i=count-1;i>=0;i--) {
 // dokladnie tak jak wyzej!
  if (dlugosc[i] == max) 
  	tcurrent=current;
  else 
  	tcurrent = current - (max-dlugosc[i]);
  
  // te warunki sa wlasnie dla liczby o mniejszej dlugosci niz najdluzsza liczba
  // w ciagu ... jesli aktualnie badna liczba ma cos jeszcze na current pozycji 
  // to zachodzi pierwszy przypadek
  if(tcurrent>=0) {
    	B[C[(int)(dane[i][tcurrent]-48)]-1] = dane[i];
    	dlugosc_new[ C[(int)(dane[i][tcurrent]-48)]-1 ] = dlugosc[i];
    	C[(int)(dane[i][tcurrent]-48)]--;
  } 

  // a jesli na pozycji current juz by nic nie bylo to ... to tak jakby jest 0
  else {
    	B[C[0]-1] = dane[i];
    	dlugosc_new[ C[0]-1 ] = dlugosc[i];
    	C[0]--;
  }
  // napisy B[ C[jakiindex] - 1] s dlatego e orygianlny algorytm zakada
  // e tablice s numerowane od 1 a nie od zera!

  // uwaga! w oryginalnej wersji algorytmu NIE ma mowy o tablicy dlugosci!
  // tu trzeba to dodac to jesli liczba zmienia swoje miejsce to oczywiscie
  // w tablicy z dlugosciami ta zmiana tez musi nastapic!

 } // koniec sortowania! teraz tablica B jest posortowana wedlug pozycji current

 // ostatnie co trzeba zrobic to wywalic stara tablica i zastapic ja nowa
 // instrukcja free(dane) nie znaczy ze wywalamy z pamieci wczytane dane!
 // a tylko w praktyce wywalamy ich stary porzadek ... nasze dane sa bezpieczne
 // w tablicy B :>
 free(dane);		// ale magia :)
 free(dlugosc);
 dane = B;
 dlugosc = dlugosc_new;
}


void print_table()  // do debugowanie i w ogle :)
{
 int i;
 for(i=0;i<count;i++) 
  printf("%d (len=%d): %s\n",i+1,dlugosc[i],dane[i]);
}


void radix()	// sortowanie pozycyjne :P
{
  int i;
  for(i=max-1;i>=0;i--)
     {
      counting_sort(i);
      if(quite_mode!=0) { 
       printf("tablica posortowana wedug pozycji: %d\n",i);
       print_table();
      }
     }
}


int main(int argc,char *argv[]) 
{
  int i,j;
  char temp;   // aktualnie wczytywany znaczek
  char fuj=0;  // zmienna pomocnicza aby stwierdzi czy nie podano jakiej
  	       // bezsensownej danej.


  // najgupszy parsing parametrw wywoania na jaki mnie sta :P
  if (argc > 1) {
	for (i = 1; i < argc; i++)
		if (!(strcmp(argv[i], "--quite")))
			quite_mode = 0;
  }


  scanf("%d",&count);  // pobierz tzw. n :)
  temp=getchar();      // takie glupstwo 
  		       // - zagadka - co sie stanie jak tego nie bedzie:P

 if(count<=0) {
  printf("podano bezsensowne dane:P\n");
  printf("n musi byc wieksze od 0!\n");
  exit(-1);
 }

 // inicjalizacja pamieci :)

 dane = (char**)malloc(count*sizeof(char*));
 dlugosc = (int*)malloc(count*sizeof(int));

 // pobieramy liczby
 for(i=0;i<count;i++){
   
   j=0;		// j - zmienna pomocnicza dlatego bo pobieram znak po znaku
   
   while ((temp=getchar()) != '\n') {
     if ((temp < '0')||(temp > '9')) fuj=1;
     dane[i] = realloc(dane[i],j+2);  // stary numer :) zeby pobierac duze napisy
     dane[i][j]=temp;     		
     dane[i][++j]='\0';   
   }

   if (fuj==0) {
     dlugosc[i]=j;	// uzupelniamy tablice dlugosci
     if (dlugosc[i] > max) max=dlugosc[i]; // wyliczamy dlugosc najdluzszego napisu jaki jest
   } 
   else { 
     printf("podae niepoprawn liczb - podaj j jeszcze raz!\n");
     free(dane[i]);
     fuj = 0;
     i--;
   }

 }

  if (quite_mode != 0) {
    printf("tablica przed sortowaniem:\n");
    print_table();
  }
 
  radix();

  if (quite_mode != 0) {
    printf("tablica po sortowaniu:\n");
    print_table();
  }
   
  return(0);
}
