// (c) 2005 W. Bolt <ja@hope.art.pl>
// na bazie kodu napisanego przez dr P. Paczkowski <pmp@math.univ.gda.pl>

#ifndef _TREE_H_
#define _TREE_H_

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <time.h>
#include <math.h>
#include <ctype.h>


typedef enum  { BLACK = 0 , RED = 1 } Kolor;

/* struktury danych do reprezentowania drzewa */
typedef struct wezel *Wskwezla; /* wskaznik na wezel drzewa  */
typedef struct wezel{
	int klucz;
	Wskwezla lewy, prawy, ojciec;
	Kolor kolor;
} Twezla ;  /* typ wezla */

/* drzewa z wartownikami: wezel wskazywany przez "nil" jest wartownikiem 
   zastepujacym NULL; pole ojciec musi byc ustawione odpowiednio w 
   przy usuwaniu */
extern Wskwezla nil; 

/* funkcja inicjujaca nil; musi byc wywolana przed budowaniem drzewa */
void nilInit(void);

/* funkcja drukujaca drzewo binarne na ekranie (tutaj tylko deklaracja) */
/* funkcja drukuje drzewo o korzeniu "w"                                */
void drukuj(Wskwezla w);

/* funkcja budujaca pelne drzewo binarne o wysokosci n;       */
/* kluczami sa kolejne liczby  naturalne zaczynajac od 1      */
Wskwezla buduj(int n);

Wskwezla szukaj (int n, Wskwezla root);

Wskwezla Left_Rotate(Wskwezla T,Wskwezla x);
Wskwezla Right_Rotate(Wskwezla T,Wskwezla x);

Wskwezla RB_Insert(Wskwezla T,int key);

int TreeHeight(Wskwezla w);

int TreeMax(Wskwezla w);
int TreeMin(Wskwezla w);

#endif
